// code by jph
package mid;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiDevice.Info;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.Receiver;

/** audio is a singleton */
public final class MidiOut extends Midi {
  public static final MidiOut instance = new MidiOut();

  private MidiOut() {
  }

  @Override
  protected boolean acceptMidiDevice(Info myInfo) throws Exception {
    return hasReceiver(MidiSystem.getMidiDevice(myInfo));
  }

  private static boolean hasReceiver(MidiDevice myMidiDevice) {
    int rec = myMidiDevice.getMaxReceivers();
    return rec == -1 || 0 < rec;
  }

  public static Receiver getReceiver(MidiDevice myMidiDevice) throws Exception {
    // MidiDevice myMidiDevice = getMidiDevice();
    if (myMidiDevice != null && hasReceiver(myMidiDevice)) {
      if (!myMidiDevice.isOpen())
        myMidiDevice.open();
      return myMidiDevice.getReceiver();
    }
    throw new Exception("device has no receiver");
  }
  // @Override
  // protected AutoCloseable getAutoCloseable() throws Exception {
  // MidiDevice myMidiDevice = getMidiDevice();
  // if (hasReceiver(myMidiDevice))
  // return myMidiDevice.getReceiver();
  // throw new Exception("device has no receiver");
  // }
}
