// code by jph
package mid.rmi;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.ArrayList;
import java.util.List;

public class RemoteMidiOutputServers {
  public static List<String> available() {
    List<String> myList = new ArrayList<>();
    try {
      Registry myRegistry = LocateRegistry.getRegistry(RemoteMidiOutputServer.OBJECT_SERVER_PORT);
      for (String myString : myRegistry.list())
        if (myString.startsWith(RemoteMidiOutputServer.prefix))
          myList.add(myString);
    } catch (RemoteException myRemoteException) {
      System.out.println(myRemoteException.getMessage());
    }
    return myList;
  }

  /** @param myString from the list of available()
   * @return */
  public static RemoteMidiOutput getRemoteMidiOutput(String myString) {
    try {
      return (RemoteMidiOutput) Naming.lookup("rmi:" + RemoteMidiOutputServer.host + myString);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }
}
