// code by jph
package sys;

import java.io.File;

public class Filename {
  public final File myFile;
  public final String myTitle;
  public final String myExtension;

  public Filename(File myFile) {
    this.myFile = myFile;
    String myString = myFile.getName();
    int index = myString.lastIndexOf('.');
    if (0 <= index) {
      myTitle = myString.substring(0, index);
      myExtension = myString.substring(index + 1);
    } else {
      myTitle = myString;
      myExtension = "";
    }
  }

  public boolean hasExtension(String myString) {
    return myExtension.equalsIgnoreCase(myString);
  }

  /** @param myString if null, produces file with title only, for instance to use as a directory
   * @return */
  public File withExtension(String myString) {
    return new File(myFile.getParentFile(), myTitle + (myString == null ? "" : "." + myString));
  }
}
