// code by jph
package sys.dat;

import java.util.Stack;

public class PerformanceNode {
  private static long init = System.nanoTime();
  private static long prev = init;
  private static Stack<String> stack = new Stack<>();

  private PerformanceNode() {
  }

  private static synchronized void insert(String myString) {
    long next = System.nanoTime();
    System.out.println(String.format("%s  %s  %s", //
        DurationChop.fromNanos(next - init).toHMSM(), //
        DurationChop.fromNanos(next - prev).toSM(), //
        myString));
    prev = next;
  }

  public static void push(String myString) {
    insert("push " + stack.push(myString));
  }

  public static void pop() {
    insert(" pop " + stack.pop());
  }
}
