package sys.gui;

import java.awt.BorderLayout;
import java.awt.Dialog.ModalityType;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.WindowConstants;

public class JListDialog<Type> {
  JDialog myJDialog;
  DefaultListModel<Type> myListModel = new DefaultListModel<>();

  public JListDialog() {
    myJDialog = new JDialog(null, "", ModalityType.APPLICATION_MODAL);
    myJDialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    JList<Type> myJList = new JList<>(myListModel);
    myJList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    JPanel myJPanel = new JPanel(new BorderLayout());
    JScrollPane myJScrollPane = new JScrollPane(myJList, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    myJPanel.add("Center", myJScrollPane);
    JToolBar myJToolBar = ComponentFactory.getJToolBar(false);
    JButton myJButton = new JButton("ok");
    myJButton.addActionListener(myActionEvent -> {
      System.out.println("exit");
      myJDialog.dispose();
      // ---
      
    });
    myJToolBar.add(myJButton);
    myJPanel.add("South", myJToolBar);
    myJDialog.setContentPane(myJPanel);
    // ---
    myJDialog.addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent e) {
        System.out.println("closing"); // cancel
      }

      @Override
      public void windowClosed(WindowEvent e) {
        System.out.println("closed");
      }
    });
  }

  void setVisible() {
    myJDialog.setVisible(true);
  }

  public static void main(String[] args) {
    JListDialog<Integer> myJListDialog = new JListDialog<>();
    myJListDialog.myListModel.add(0, 3);
    myJListDialog.myListModel.add(1, 8);
    myJListDialog.myListModel.add(2, 20);
    myJListDialog.myJDialog.setBounds(100, 100, 400, 300);
    myJListDialog.setVisible();
  }
}
