// code by jph
package sys.gui;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.JProgressBar;
import javax.swing.SwingConstants;

public abstract class ScalarPanel {
  private static final int max = 1000;
  public JProgressBar myJProgressBar = new JProgressBar(SwingConstants.HORIZONTAL, 0, max);

  public ScalarPanel(double myDouble) {
    setValueEvent(myDouble);
    myJProgressBar.setStringPainted(true);
    myJProgressBar.addMouseListener(new MouseAdapter() {
      @Override
      public void mousePressed(MouseEvent myMouseEvent) {
        if (myJProgressBar.isEnabled()) {
          int myInt = myMouseEvent.getPoint().x * max / myJProgressBar.getSize().width;
          myInt = updateGui(myInt);
          setValueEvent(myInt / (double) max);
        }
      }
    });
    myJProgressBar.addMouseMotionListener(new MouseMotionAdapter() {
      @Override
      public void mouseDragged(MouseEvent myMouseEvent) {
        if (myJProgressBar.isEnabled()) {
          int myInt = myMouseEvent.getPoint().x * max / myJProgressBar.getSize().width;
          myInt = updateGui(myInt);
          setValueEvent(myInt / (double) max);
        }
      }
    });
    myJProgressBar.addMouseWheelListener(new MouseWheelListener() {
      @Override
      public void mouseWheelMoved(MouseWheelEvent myMouseWheelEvent) {
        if (myJProgressBar.isEnabled()) {
          int myInt = myJProgressBar.getValue();
          myInt -= myMouseWheelEvent.getWheelRotation() * max / 100; // one percent change
          myInt = updateGui(myInt);
          setValueEvent(myInt / (double) max);
        }
      }
    });
  }

  public void setEnabled(boolean enabled) {
    // myJProgressBar.setForeground(enabled ? Color.red : Color.lightGray);
    // myJProgressBar.setBackground(enabled ? Color.blue : Color.white);
    myJProgressBar.setEnabled(enabled);
    // myJProgressBar.repaint();
  }

  private int updateGui(int myInt) {
    myInt = Math.min(Math.max(0, myInt), max);
    myJProgressBar.setValue(myInt);
    myJProgressBar.setString(String.format("%d%%", myInt * 100 / max));
    return myInt;
  }

  public void setValueFromExtern(double myDouble) {
    int myInt = (int) Math.floor(myDouble * max);
    myInt = Math.min(Math.max(0, myInt), max);
    updateGui(myInt);
  }

  public abstract void setValueEvent(double myDouble);
}
