// code by jph
package sys.lic;

import java.io.File;
import java.util.Date;

import sys.Manager;

public class BuildInfo {
  private static final String key = "Timestamp";
  private static BuildInfo instance = null;

  public static BuildInfo getInstance() {
    if (instance == null)
      instance = new BuildInfo();
    return instance;
  }

  // ---
  private final File myFile = new File("src", getClass().getCanonicalName().replace('.', File.separatorChar) + ".java");
  private Manager myManager = new Manager(getClass());

  private BuildInfo() {
    if (isDevelopmentVersion()) {
      myManager.setProperty(key, "" + new Date());
      myManager.manifest();
    }
  }

  public final boolean isDevelopmentVersion() {
    return myFile.exists();
  }

  public String getTimestamp() {
    return myManager.getString(key, "unknown");
  }
}
