// code by jph
package sys.lic;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

public class License {
  public static DateFormat myDateFormat = new SimpleDateFormat("yyyy-MM-dd/HH:mm:ss");

  private static CryptBytes getCryptBytes(String myString) {
    try {
      return new CryptBytes(new String(myString));
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }

  // ---
  String myIPstart = null;
  Calendar myBeg = null;
  Calendar myEnd = null;

  License() {
  }

  static License retrieve(String myString, File myFile) {
    try {
      FileInputStream myFileInputStream = new FileInputStream(myFile);
      byte[] myByte = new byte[myFileInputStream.available()];
      myFileInputStream.read(myByte);
      myFileInputStream.close();
      return fromBytes(myString, myByte);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }

  public static License manifest(String myString, File myFile, String myIPstart, Calendar myBeg, Calendar myEnd) {
    License myLicense = new License();
    myLicense.myIPstart = myIPstart;
    myLicense.myBeg = myBeg;
    myLicense.myEnd = myEnd;
    try {
      FileOutputStream myFileOutputStream = new FileOutputStream(myFile);
      myFileOutputStream.write(myLicense.toBytes(myString));
      myFileOutputStream.close();
      return myLicense;
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }

  byte[] toBytes(String myString) {
    try {
      ByteArrayOutputStream myByteArrayOutputStream = new ByteArrayOutputStream();
      ObjectOutputStream myObjectOutputStream = new ObjectOutputStream(myByteArrayOutputStream);
      myObjectOutputStream.writeObject(myIPstart);
      myObjectOutputStream.writeObject(myBeg);
      myObjectOutputStream.writeObject(myEnd);
      myObjectOutputStream.close();
      return getCryptBytes(myString).encrypt(myByteArrayOutputStream.toByteArray());
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }

  static License fromBytes(String myString, byte[] myByte) {
    try {
      License myLicense = new License();
      ByteArrayInputStream myByteArrayInputStream = new ByteArrayInputStream(getCryptBytes(myString).decrypt(myByte));
      ObjectInputStream myObjectInputStream = new ObjectInputStream(myByteArrayInputStream);
      myLicense.myIPstart = (String) myObjectInputStream.readObject();
      myLicense.myBeg = (Calendar) myObjectInputStream.readObject();
      myLicense.myEnd = (Calendar) myObjectInputStream.readObject();
      myObjectInputStream.close();
      return myLicense;
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }

  @Override
  public String toString() {
    return "IPstart [" + myIPstart + "] beg: " + myDateFormat.format(myBeg.getTime()) + "\nend: " + myDateFormat.format(myEnd.getTime());
  }

  public boolean inInterval(Calendar myCalendar) {
    return myBeg.compareTo(myCalendar) == -1 && myCalendar.compareTo(myEnd) == -1;
  }

  public static void main(String[] args) {
    try {
      Calendar myCalendarBeg = Calendar.getInstance();
      // myCalendarBeg.setTime(myDateFormat.parse("2012-12-02/11:03:54"));
      Calendar myCalendarEnd = Calendar.getInstance();
      myCalendarEnd.setTime(myDateFormat.parse("2012-12-31/12:00:00"));
      // ---
      System.out.println(myDateFormat.format(myCalendarBeg.getTime()));
      System.out.println(myDateFormat.format(myCalendarEnd.getTime()));
    } catch (ParseException myException) {
      myException.printStackTrace();
    }
  }
}