// code by jph
package sys.mat;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import sys.Manager;

/** uses variation of quicksort */
public class Median<Type extends Comparable<Type>> {
  final List<Type> myList;
  final int sep;
  public final Type value;

  public Median(Collection<Type> myCollection) {
    myList = new ArrayList<>(myCollection);
    sep = myList.size() / 2;
    median(0, myList.size() - 1, myList);
    System.out.println(myList);
    System.out.println("^");
    value = myList.get(sep);
  }

  private void median(int a, int b, List<Type> myList) {
    int c1 = a;
    int c2 = b;
    int ind = (a + b) / 2;
    Type ref = myList.get(ind);
    do {
      while (myList.get(c1).compareTo(ref) < 0)
        ++c1;
      while (myList.get(c2).compareTo(ref) > 0)
        --c2;
      if (c1 <= c2) {
        Collections.swap(myList, c1, c2);
        ++c1;
        --c2;
      }
    } while (c1 <= c2);
    if (a < c2 && sep <= c2)
      median(a, c2, myList);
    if (c1 < b && c1 <= sep)
      median(c1, b, myList);
  }

  static <Type extends Comparable<Type>> void sort(List<Type> myList) {
    sort(0, myList.size() - 1, myList);
  }

  private static <Type extends Comparable<Type>> void sort(int a, int b, List<Type> myList) {
    int c1 = a;
    int c2 = b;
    int ind_ = (a + b) / 2; // selects middle index as reference
    Type ref = myList.get(ind_);
    do {
      while (myList.get(c1).compareTo(ref) < 0)
        ++c1;
      while (myList.get(c2).compareTo(ref) > 0)
        --c2;
      if (c1 <= c2) {
        Collections.swap(myList, c1, c2);
        ++c1;
        --c2;
      }
    } while (c1 <= c2);
    if (a < c2)
      sort(a, c2, myList);
    if (c1 < b)
      sort(c1, b, myList);
  }

  public static void test() {
    List<Integer> myList = new ArrayList<>();
    new IntRange(30).forEach(i -> myList.add(Manager.random.nextInt(100)));
    List<Integer> myCopy = new ArrayList<>(myList);
    // ---
    System.out.println(myList);
    System.out.println("median = " + new Median<>(myList).value);
    sort(0, myCopy.size() - 1, myCopy);
    System.out.println(myCopy);
    System.out.println("median = " + myCopy.get(myList.size() / 2));
  }

  public static void main(String[] args) {
    test();
  }
}
