// code by jph
package sys.mat;

import java.util.IntSummaryStatistics;

/** intended to keep track of ratios of the form parts/total */
public class Ratio {
  private static final int prime = Primes.lessEq(256 * 256);
  // ---
  public int num; // numerator
  public int den; // denominator

  public Ratio() {
  }

  public Ratio(int num, int den) {
    this.num = num;
    this.den = den;
  }

  public Ratio(IntSummaryStatistics myIntSummaryStatistics) {
    num = (int) myIntSummaryStatistics.getSum();
    den = (int) myIntSummaryStatistics.getCount();
  }

  public Ratio(Fraction myFraction) {
    num = myFraction.num;
    den = myFraction.den;
  }

  public Fraction toFraction() {
    return new Fraction(num, den);
  }

  public double toDouble() {
    return num / (double) den;
  }

  /** separator character is '/'
   * whitespace is removed before Integer.parseInt is invoked
   * 
   * @param myString
   * @return */
  public static Ratio parseRatio(String myString) {
    String[] mySplit = myString.split("/");
    return new Ratio(Integer.parseInt(mySplit[0].trim()), Integer.parseInt(mySplit[1].trim()));
  }

  @Override
  public boolean equals(Object myObject) {
    Ratio myRatio = (Ratio) myObject;
    return num == myRatio.num && den == myRatio.den;
  }

  @Override
  public int hashCode() {
    return num * prime + den;
  }

  @Override
  public String toString() { // used for music meter
    return num + "/" + den;
  }
}
