package sys.mat;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;
import java.util.stream.Collectors;

public class Variance {
  public static double of(Map<Integer, Long> myFreq) {
    double mean;
    long total = 0;
    {
      long nomin = 0;
      for (Entry<Integer, Long> myEntry : myFreq.entrySet()) {
        int sym = myEntry.getKey(); //
        long mul = myEntry.getValue();
        nomin += sym * mul;
        total += mul;
      }
      mean = nomin / (double) total;
      System.out.println("mean " + mean);
    }
    double top = 0;
    {
      for (Entry<Integer, Long> myEntry : myFreq.entrySet()) {
        int sym = myEntry.getKey(); //
        long mul = myEntry.getValue();
        double delta = sym - mean;
        top += delta * delta * mul;
      }
    }
    return top / (total - 1);
  }

  public static void main(String[] args) {
    // List<Integer> myList = Arrays.asList(new Integer[] { -2, 3, 10, 2, 10, 2, 2, 2, 10, 10, 8, 2 });
    Random r = new Random();
    int n = 10;
    List<Integer> myList = new IntRange(100000).stream() //
        .map(i -> r.nextInt(n)) //
        .boxed() //
        .collect(Collectors.toList());
    // PerformanceNode.insert("warm up");
    // myList.stream().collect(Collectors.toList());
    Map<Integer, Long> myMap = FrequencyMap.unsortedLong(myList.stream());
    System.out.println(of(myMap));
    System.out.println((n * n - 1) / 12.0);
    // PerformanceNode.insert("unsorted");
    // new TreeMap<>(unsortedLong(myList.stream()));
    // PerformanceNode.insert("sorted");
    // sortedInt(myList.stream());
    // PerformanceNode.insert("sorted alt");
    // sortedIntAlt(myList.stream());
    // PerformanceNode.insert();
  }
}
