// code by jph
package sys.mat.num;

import java.util.Arrays;
import java.util.List;

public class CubicSubdivision {
  public static List<Double> curve(List<Double> myList) {
    Double[] myDouble = new Double[myList.size() * 2 - 1];
    int index = 0;
    for (double value : myList) {
      myDouble[index] = value;
      index += 2;
    }
    // linear subdivision, methodology by Scott Schaefer and Joe Warren
    for (index = 1; index < myDouble.length; index += 2)
      myDouble[index] = (myDouble[index - 1] + myDouble[index + 1]) * 0.5;
    // smoothing
    double prev = myDouble[0];
    for (index = 1; index < myDouble.length - 1; ++index) {
      double next = myDouble[index];
      myDouble[index] = (prev + 2 * myDouble[index] + myDouble[index + 1]) * 0.25;
      prev = next;
    }
    return Arrays.asList(myDouble);
  }

  public static List<Double> curve(List<Double> myList, int iterations) {
    for (int count = 0; count < iterations; ++count)
      myList = curve(myList);
    return myList;
  }

  public static void main(String[] args) {
    List<Double> myList = CubicSubdivision.curve(Arrays.asList(new Double[] { 2., 1., -1., 2. }), 2);
    System.out.println(myList);
    System.out.println(myList.size());
  }
}
