// code by jph
package sys.ref;

import java.io.File;
import java.util.LinkedList;
import java.util.List;

import sys.mat.Fraction;

public class ClassInfo extends CodePoint {
  final Class<?> myClass;

  public ClassInfo(Class<?> myClass) {
    this.myClass = myClass;
  }

  public int getLength() {
    File myFile = new File("src\\" + myClass.getCanonicalName().replace('.', '\\') + ".java");
    return myFile.exists() ? (int) myFile.length() : 0;
  }

  @Override
  public String toString() {
    int myInt = myClass.getInterfaces().length;
    List<String> myList = new LinkedList<>();
    for (Class<?> myInter : myClass.getInterfaces())
      myList.add(myInter.getSimpleName());
    int length = getLength();
    // String myString = myClass.getSuperclass().getName().equals("java.lang.Object") ? myClass.getName() : myClass.getSimpleName();
    // return myString + (0 < myInt ? " " + myList : "");
    return myClass.getSimpleName() + (0 < length ? " " + new Fraction(length, 1024).ceil() + "kB" : "") + (0 < myInt ? " " + myList : "");
  }

  @Override
  String getCompareString() {
    return myClass.getName();
  }
}
