// code by jph
package sys.ref;

import java.io.File;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class ClassTree extends ClassVisitor {
  public static final String tabs = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
  // ---
  public Map<ClassInfo, Set<ClassInfo>> myMap = new TreeMap<>();

  public ClassTree(String myString) throws Exception {
    visitRecursively(new File(myString));
    Class<?> myClass = Class.forName("java.lang.Object"); // FingeringRow
    recur(0, new ClassInfo(myClass));
  }

  public void recur(int level, ClassInfo myClassInfo) {
    for (ClassInfo mySub : myMap.get(myClassInfo)) {
      System.out.println(tabs.substring(0, level) + mySub.toString());
      recur(level + 1, mySub);
    }
  }

  @Override
  public void visitFile(File myFile, Class<?> myClass) {
    while (myClass != null) {
      Class<?> mySuper = myClass.getSuperclass();
      ClassInfo myClassInfoClass = new ClassInfo(myClass);
      if (!myMap.containsKey(myClassInfoClass))
        myMap.put(myClassInfoClass, new TreeSet<>());
      if (mySuper != null) {
        ClassInfo myClassInfoSuper = new ClassInfo(mySuper);
        if (!myMap.containsKey(myClassInfoSuper))
          myMap.put(myClassInfoSuper, new TreeSet<>());
        myMap.get(myClassInfoSuper).add(myClassInfoClass);
      }
      myClass = mySuper;
    }
  }

  public static void main(String[] args) throws Exception {
    new ClassTree("src/tpf");
    System.exit(0);
  }
}
