// code by jph
package sys.wav;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.TargetDataLine;

public class WaveIn extends Wave {
  public static final WaveIn instance = new WaveIn();

  private WaveIn() {
  }

  @Override
  protected boolean acceptDataLine(DataLine.Info myDataLineInfo, AudioFormat myAudioFormat) {
    try {
      TargetDataLine myTargetDataLine = (TargetDataLine) AudioSystem.getLine(myDataLineInfo);
      myTargetDataLine.open(myAudioFormat);
      myTargetDataLine.close();
    } catch (Exception myException) {
      return false;
    }
    return true;
  }

  public TargetDataLine lineFrom(final MixerDataFormat myMixerDataFormat) {
    try {
      return (TargetDataLine) AudioSystem.getLine(myMixerDataFormat.myDataLineInfo);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return null;
  }
}
