// code by jph
package sys.wav.get;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.Control;
import javax.sound.sampled.Control.Type;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;

/** implements all the (so far) never-used functions of TargetDataLine so that other targetDataLines can extend from here */
public abstract class TargetDataLineReduced implements TargetDataLine {
  @Override
  public final int available() {
    int myInt = 0;
    log("available() " + myInt);
    return myInt;
  }

  @Override
  public final void drain() {
    log("drain()");
  }

  @Override
  public final int getFramePosition() {
    int myInt = 0;
    log("getFramePosition() " + myInt);
    return myInt;
  }

  @Override
  public final float getLevel() {
    // returns -1.0
    float myFloat = -1.0f;
    log("getLevel() " + myFloat);
    return myFloat;
  }

  @Override
  public final long getLongFramePosition() {
    long myLong = 0;
    log("getLongFramePosition() " + myLong);
    return myLong;
  }

  @Override
  public final long getMicrosecondPosition() {
    long myLong = 0;
    log("getMicrosecondPosition() " + myLong);
    return myLong;
  }

  @Override
  public final boolean isActive() {
    // true during readout
    boolean myBoolean = true;
    log("isActive() " + myBoolean);
    return myBoolean;
  }

  @Override
  public final boolean isRunning() {
    // true during readout
    boolean myBoolean = true;
    log("isRunning() " + myBoolean);
    return myBoolean;
  }

  @Override
  public final void addLineListener(LineListener myLineListener) {
    log("addLineListener()");
    // myTargetDataLine.addLineListener(myLineListener);
  }

  @Override
  public final Control getControl(Type myType) {
    Control myControl = null;
    log("getControl() " + myControl);
    return myControl;
  }

  @Override
  public final Control[] getControls() {
    Control[] myControl = new Control[0];
    log("getControls() [" + myControl.length + "]");
    return myControl;
  }

  @Override
  public final javax.sound.sampled.Line.Info getLineInfo() {
    javax.sound.sampled.Line.Info myInfo = null;
    log("getLineInfo() " + myInfo);
    return myInfo;
  }

  @Override
  public final boolean isControlSupported(Type myType) {
    boolean myBoolean = true;
    log("isControlSupported() " + myBoolean);
    return myBoolean;
  }

  @Override
  public final void open() throws LineUnavailableException {
    // this is called by the advanced Isis library
    // log("open0()");
  }

  @Override
  public final void open(AudioFormat myAudioFormat) throws LineUnavailableException {
    log("open(AudioFormat) " + myAudioFormat);
  }

  @Override
  public final void removeLineListener(LineListener myLineListener) {
    log("removeLineListener()");
  }

  private  static final void log(String myString) {
    new Exception(myString).printStackTrace();
  }
}
