// code by jph
package sys.wav.get;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.TargetDataLine;

public class TargetDataLineSpy extends TargetDataLineReduced {
  final TargetDataLine myTargetDataLine;

  public TargetDataLineSpy(TargetDataLine myTargetDataLine) {
    this.myTargetDataLine = myTargetDataLine;
  }

  @Override
  public void flush() { // called before closing
    prn("flush()");
    myTargetDataLine.flush();
  }

  @Override
  public int getBufferSize() { // 38400
    int myInt = myTargetDataLine.getBufferSize();
    prn("getBufferSize() " + myInt);
    return myInt;
  }

  @Override
  public AudioFormat getFormat() {
    // PCM_SIGNED 38400.0 Hz, 16 bit, mono, 2 bytes/frame, big-endian
    AudioFormat myAudioFormat = myTargetDataLine.getFormat();
    prn("getFormat() " + myAudioFormat);
    return myAudioFormat;
  }

  @Override
  public void start() {
    prn("start()");
    myTargetDataLine.start();
  }

  @Override
  public void stop() {
    prn("stop()");
    myTargetDataLine.stop();
  }

  @Override
  public void close() {
    prn("close()");
    myTargetDataLine.close();
  }

  @Override
  public void open(AudioFormat myAudioFormat, int myInt) {
    try {
      prn("open(AudioFormat, int) " + myAudioFormat + " (" + myInt + ")");
      myTargetDataLine.open(myAudioFormat, myInt);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
  }

  @Override
  public boolean isOpen() {
    boolean myBoolean = myTargetDataLine.isOpen();
    prn("isOpen() " + myBoolean);
    return myBoolean;
  }

  @Override
  public int read(byte[] myByte, int ofs, int len) {
    int myInt = myTargetDataLine.read(myByte, ofs, len); // len = 512
    return myInt;
  }

  private final void prn(String myString) {
  }
}
